# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_xss_rule-XSSReqParamToServletWriter"
    languages:
      - "kotlin"
    message: |
      Servlet reflected cross site scripting vulnerability
    severity: "WARNING"
    metadata:
      shortDescription: "Improper neutralization of input during web page generation ('Cross-site Scripting')"
      category: "security"
      cwe: "CWE-79"
      owasp:
        - "A1:2017-Injection"
        - "A03:2021-Injection"
      technology:
        - "kotlin"
      security-severity: "MEDIUM"

    mode: "taint"
    pattern-sanitizers:
      - patterns:
          - pattern-inside: |-
              org.owasp.encoder.Encode.forHtml($TAINTED);
          - pattern: "$TAINTED"
    pattern-sinks:
      - patterns:
          - pattern-inside: |-
              fun $FUNC(..., $RES: HttpServletResponse , ...) {...}
          - pattern-inside: |
              $WRITER = $RES.getWriter();
              ...
          - pattern: "$WRITER.write($DATA,...);"
          - pattern: "$DATA"
      - patterns:
          - pattern-inside: |-
              fun $FUNC(..., $RES: HttpServletResponse , ...) {...}
          - pattern: "$RES.getWriter().write($DATA,...);"
          - pattern: "$DATA"
    pattern-sources:
      - patterns:
          - pattern-inside: |-
              fun $FUNC(..., $REQ: HttpServletRequest , ...) {...}
          - pattern: "$REQ.getParameter(...);"
